SystemOrganization addCategory: #'RPackage-Tests'!

RPackage subclass: #MCMockRPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!MCMockRPackage commentStamp: 'cyrilledelaunay 1/24/2011 16:16' prior: 0!
This class should be used instead of MCMockPackageInfo in the monticello tests!

!MCMockRPackage class methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/3/2012 23:29'!
initialize
	[self packageOrganizerClass default registerPackage: self new ] on: MessageNotUnderstood do: []! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classNames
	^ #(	MCMockClassA
		 	MCMockASubclass
			MCMockClassB
			MCMockClassD
			MCMockClassE
			MCMockClassF
			MCMockClassG
			MCMockClassH
			MCMockClassI
		)! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classes
	^ self classNames select: [ :tmpName | Smalltalk globals hasClassNamed: tmpName ] thenCollect: [ :tmpName | Smalltalk globals at: tmpName ]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesClass: aClass
	^self classes includes: aClass! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesSystemCategory: categoryName
	^self systemCategories anySatisfy: [:cat | cat sameAs: categoryName]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:50:00+01:00'!
name

	^ self packageName! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
packageName
	^ 'MonticelloMocks'! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 7/4/2012 21:07'!
systemCategories
	^ Array with: 'MonticelloMocks'! !

TestCase subclass: #RPackageTestCase
	instanceVariableNames: 'announcerForTest oldSystemAnnouncer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

RPackageTestCase subclass: #RPackageImportFromPackageInfoTest
	instanceVariableNames: 'emptyOrganizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:01'!
XPackageName

	^ #X! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:01'!
XSubcategoryName

	^ 'X-Subcategory'! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:12'!
classInXSubcategoryName

	^#ClassInXSubcategory! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'PavelKrivanek 7/18/2012 12:51'!
cleanClassesPackagesAndCategories

	|mCPackage|
	Smalltalk globals removeClassNamed: self classInXSubcategoryName.
	Smalltalk organization removeCategory: self XPackageName asString.
	Smalltalk organization removeCategory: self XSubcategoryName.
	mCPackage := self allManagers 
							detect: [:each | each packageName = self XPackageName] 
							ifNone: [nil].
	PackageOrganizer default unregisterPackage: (PackageOrganizer default packagesDictionary at: self XPackageName).
	mCPackage ifNotNil: [mCPackage unregister].
			! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createMethodNamed: methodName inClass: aClass inCategory: aCategoryName 

	^ aClass compile: (methodName, ' ^nil') classified: aCategoryName.! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createNewClassNamed: aName inCategory: aCategoryName
	
	| cls |
	cls := Object subclass: aName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategoryName.
	^ cls! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'PavelKrivanek 7/18/2012 12:55'!
createNewMCPackageNamed: aSymbol

	PackageInfo registerPackageName: aSymbol.
	MCWorkingCopy forPackage: (MCPackage new name: aSymbol)! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createNewTraitNamed: aName inCategory: aCategoryName
	
	| trait |
	trait := Trait named: aName asSymbol
			uses: {}
			category: aCategoryName.
	^ trait! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:02'!
createXPackage

	self createNewMCPackageNamed: self XPackageName! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:03'!
createXSubCategory

	Smalltalk globals organization addCategory: self XSubcategoryName.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:15'!
createXSubCategoryClass

	^ self createNewClassNamed:  self classInXSubcategoryName inCategory:  self XSubcategoryName.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/18/2011 13:50'!
emptyOrganizer

	^ emptyOrganizer! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setUp 
	super setUp.
	emptyOrganizer := self packageOrganizerClass new debuggingName: 'RPackageImportsFromPackageInfo Package Organizer'.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'GuillermoPolito 4/27/2012 13:27'!
tearDown
	self cleanClassesPackagesAndCategories.
	super tearDown.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:02'!
testImportExtensionFromParentPackageRegisterExtensionInParentPackage

	"
	When importing from PackageInfo :
	test that when a package extend a class from a sub-category of this package, the extension method is well registered as extension method of this package "
	"self run: #testImportExtensionFromParentPackageRegisterExtensionInParentPackage"
	|tmpClass XPackage|
	[self createXPackage.
	self createXSubCategory.
	tmpClass := self createXSubCategoryClass.
	self createMethodNamed:  #stubMethod inClass: tmpClass inCategory: '*',self XPackageName asString.
	self emptyOrganizer importFromPackageInfo: (PackageOrganizer default packagesDictionary at: self XPackageName asString).
	self emptyOrganizer importFromPackageInfo: (PackageOrganizer default packagesDictionary at: self XSubcategoryName).
	XPackage := self emptyOrganizer packageNamed: self XPackageName.
	"this test does not work because we have two different organizers: one from emptyOrganizer and one reached by the propagation of event"
	"self assert: ((tmpClass>>#stubMethod) packageFromOrganizer: self emptyOrganizer)  = XPackage."
	self assert: (XPackage includesExtensionSelector:  #stubMethod ofClass: tmpClass).   
	] 

	ensure: [
		emptyOrganizer = nil
	] 	   ! !

RPackageTestCase subclass: #RPackageIncrementalTest
	instanceVariableNames: 'createdClasses createdPackages createdCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageIncrementalTest commentStamp: 'StephaneDucasse 5/15/2010 20:21' prior: 0!
The tests takes as fixture the following situation (which is constructed partially)
For tests that do not need to check the incremental construction.


P1 
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
P2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3  (was *P2*)!

RPackageIncrementalTest subclass: #RPackageCompleteSetupButForModificationTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageCompleteSetupButForModificationTest methodsFor: 'setup' stamp: '2010-11-26T09:22:00+01:00'!
setUp
	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3)

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:53:00+01:00'!
testAddMethod
	"self debug: #testAddMethod"
	
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	
	a1 compileSilently: 'zork ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#zork).
	self assert: (p1 includesSelector: #zork ofClass: a1).
	
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:59:00+01:00'!
testBasicRemoveClass
	"we remove a class we check that it is not in the package anymore"
	"self debug: #testBasicRemoveClass"	

	|  size |
	size := p1 definedClasses size. 
	self assert: size = 2.
	self assert: (p1 includesClass: a1).
	self assert: (p1 includesClass: a1 class).
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = (size - 1).
	self assert: (p1 includesClass: b1).
	self assert: (p1 includesClass: b1 class).
	self deny: (p1 includesClass: a1).
	self deny: (p1 includesClass: a1 class).
	p1 removeClassDefinition: b1.
	self assert: p1 definedClasses size = (size - 2).
	self deny: (p1 includesClass: b1).
	self deny: (p1 includesClass: b1 class).

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-24T22:31:00+01:00'!
testExtensionMethodOfClass
	"self debug: #testExtensionMethodOfClass"
	
	"P1 
		A1DefinedInP1>>methodDefinedInP1
		B1DefinedInP1	
		A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
	P2
		A2DefinedInP2>>methodDefinedInP2
		B2DefinedInB2	

	P3
		A3DefinedInP3	
		A2DefinedInP2>>methodDefinedInP3  (was *P2*)"
		
	self assert: a2 methodDict keys size = 3.
	"the class contains methods defined by several packages 
	however when looking with a package view we only see the package 
	extension."
		
	self assert: (p2 extensionMethodsForClass: a2) size = 0.
	self assert: (p1 extensionMethodsForClass: a1) size = 0.
	"show that extensionMethodsForClass: does works for methods of class
	defined in the package"
	
	self assert: (p1 extensionMethodsForClass: a2) size = 1.
	self assert: (p3 extensionMethodsForClass: a2) size = 1.! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveMethod
	"self debug: #testRemoveMethod"
	
	p1 removeMethod: a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:27:00+01:00'!
testRemoveMethodDoesNotRemoveFromClass
	"we remove a method so it is not in the package but also not from the class anymore"
	"self debug: #testRemoveMethodDoesNotRemoveFromClass"
	
	p1 removeMethod:  a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (a1 selectors includes: #methodDefinedInP1)! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveShouldRaiseErrorWhenMethodIsNotInPackage
	"self debug: #testRemoveShouldRaiseErrorWhenMethodIsNotInPackage"
	
	self should: [p2 removeMethod: a2>>#methodDefinedZork] raise: Error! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-22T07:52:00+01:00'!
testStartingSituation
	"self debug: #testStartingSituation"
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T15:41:00+01:00'!
createNewClassNamed: aName
	^ self createNewClassNamed: aName inCategory: 'RPackageTest'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:16:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	createdCategories add: cat.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-03-11T13:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'EstebanLorenzano 7/27/2012 19:53'!
createNewPackageNamed: aName

	| pack |
	self removePackage: aName.
	pack := self packageClass named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 5/9/2011 16:47'!
createNewTraitNamed: aName
	^ self createNewTraitNamed: aName inCategory: 'RPackageTest'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'cyrilledelaunay 5/10/2011 11:39'!
createNewTraitNamed: aName inCategory: cat
	
	| cls |
	cls := Trait named: aName
			uses: {}
			category: cat.
	createdClasses add: cls.
	createdCategories add: cat.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 5/9/2011 17:48'!
createNewTraitNamed: aName inPackage: p
	
	| cls |
	cls := self createNewTraitNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:18:00+01:00'!
p1Name
	^ 'RPackageTestP1'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p2Name
	^ 'RPackageTestP2'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p3Name
	^ 'RPackageTestP3'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T17:18:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol
	Smalltalk at: aClassNameSymbol asSymbol ifPresent: [:c| c removeFromSystem]! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 6/3/2012 22:46'!
removePackage: aName
	self packageClass organizer basicUnregisterPackageNamed: aName.
	! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: 'GuillermoPolito 4/27/2012 13:24'!
setUp
	super setUp.
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.
	createdCategories := Set new.
	Author fullName ifNil: [Author fullName: 'RPackage'].! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 22:46'!
tearDown
	
	| logging |
	createdPackages  do: [:each | self removePackage: each name].
	"just remove package from package organizer dictionary"
	
	createdPackages  do: [:each |
		|mCPackage|
		mCPackage := self allManagers 
							detect: [:mcPackage | mcPackage packageName = each packageName asString] 
							ifNone: [nil].
		mCPackage ifNotNil: [mCPackage unregister].
		each extendedClasses do: [ :extendedClass|
			self packageClass organizer
		 		unregisterExtendingPackage: each forClass: extendedClass.]].
	"all ***extending*** classes the packages are also unregistered from PackageOrganizer"									
	(createdClasses reject: [:c| c isObsolete]) do: [:cls| 
		"(RPackage organizer includesPackageBackPointerForClass: cls) 
			ifTrue: [cls package unregisterClass: cls.]. 
		when RPackageOrganizer was not looking at system event we had to do the commented actions"
		logging := false.
		cls removeFromSystem: logging.  
		"not logging so no event are raised"
		"but this also means that the consistency cannot be ensured by internal system announcer too."
		].					
	createdCategories do: [:each | 
		|mCPackage|
		SystemOrganization removeCategory: each.
		 ].
	super tearDown.! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethods
	"self debug: #testAddClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethodsAtMetaclassToo
	"self debug: #testAddClassAfterMethodsAtMetaclassToo"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 class compileSilently: 'newlyAddedToA1Class ^ #methodDefinedInP1'.
	p1 addMethod: (a1 class>>#newlyAddedToA1Class).
	self assert: (p1 includesSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassDefinitionNoDuplicate
	"self debug: #testAddClassDefinitionNoDuplicate"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: a1.
	"adding the same class does not do anything - luckily"
	self assert: p definedClasses size = 1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveMethod
	"self debug: #testAddRemoveMethod"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	"removeMethod by default removes from defined methods and not extension"
	p2 removeMethod: (a2>>#methodDefinedInP2).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeMethod: (a2>>#methodDefinedInP1).
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:46:00+01:00'!
testAddRemoveSelector
	"self debug: #testAddRemoveSelector"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofClassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofClassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofClassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveSelectorOfMetaclass
	"self debug: #testAddRemoveSelectorOfMetaclass"
	
	| p1 p2 p3 a2   a2Name a2class |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofMetaclassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofMetaclassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofMetaclassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testBogusClassAddition
	"self debug: #testBogusClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self should: [p addClassDefinitionName: a1 class name] raise: Error.
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassAddition
	"self debug: #testClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: a1 class)
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemoval
	"self debug: #testClassDefinitionRemoval"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: b1 class.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemovalName
	"self debug: #testClassDefinitionRemovalName"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	p addClassDefinitionName: b1 name.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	self should: [p removeClassDefinitionName: b1 class name] raise: Error.
	p removeClassDefinitionName: b1  name.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testClasses
	"self debug: #testClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 classes size = 2.
	self assert: p2 classes size = 2.! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testDefinedClassesAndDefinedClassNames
	"self debug: #testDefinedClassesAndDefinedClassNames"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p definedClasses  includes: a1).
	self assert: (p definedClassNames includes: a1 name).
	
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p definedClasses includes: b1).
	self assert: (p definedClassNames includes: b1 name).
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:38:00+01:00'!
testExtensionClassNames
	"self debug: #testExtensionClassNames"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2 name.
	
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extensionMethods size = 1.
	self assert: (p1 extendedClassNames includes: #A2InPackageP2).
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addSelector: #firstMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addSelector: #secondMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testExtensionClasses
	"self debug: #testExtensionClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 1.
	self assert: (p1 extendedClasses  includes: a2).
	self assert: p1 extendedClassNames size = 1.
	self assert: (p1 extendedClassNames  includes: a2 name).
	
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClasses  includes: b2 class).
	"extensionClasses returns or metaclasses while extensionClassNames returns class names (but not metaclass names)"

	self assert: p1 extendedClassNames size = 2.
	self assert: (p1 extendedClassNames  includes: b2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:45:00+01:00'!
testExtensionClassesWithCompiledMethod
	"self debug: #testExtensionClassesWithCompiledMethod"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: b2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extendedClasses size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addMethod: (b2>>#secondMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:13:00+01:00'!
testExtensionMethods
	"self debug: #testExtensionMethods"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionSelectors  size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compileSilently: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	self assert: p1 extensionSelectors  size = 2.
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-03-11T14:35:00+01:00'!
testIncludeClass
	"self debug: #testIncludeClass"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	
	self deny: (p1 includesClass: a2).
	p1 addMethod: (a2>>#methodPackagedInP1).
	self deny: (p1 includesClass: a2).
	"We should declare the class explictly. Adding a method does not declare
	the class as defined. The reason is that like that the client controls the granularity 
	and moment of class registration."
	
	p1 addClassDefinition: a2.
	self assert: (p1 includesClass: a2).
	self assert: (p1 includesClassNamed: a2 name).
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeClassMore
	"self debug: #testIncludeClassMore"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesClass: a2).
	self deny: (p1 includesClass: a2).
	self deny: (p3 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfClass
	"self debug: #testIncludeSelectorOfClass"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2 name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofClass: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfMetaClass
	"self debug: #testIncludeSelectorOfMetaClass"
	
	| p1 p2 p3 a2  a2class |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2class>>#methodDefinedInP2).
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2class>>#methodDefinedInP1).
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2class>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2class).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClass: a2class).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofMetaclassName: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2 name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClass: a2 class).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClass: a2).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: 'StephaneDucasse 4/24/2011 20:25'!
testIncludesMethodOfClassInPresenceOfOtherPackageExtensions
	"self debug: #testIncludesMethodOfClassInPresenceOfOtherPackageExtensions"
	
	| p1 p2 p3 a2  a2name |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2name := #A2InPackageP2.
	a2 := self createNewClassNamed: a2name inPackage: p2.
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
		
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:46:00+01:00'!
testIncludesOrTouches
	"self debug: #testIncludesOrTouches"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self deny: (p1 includesClass: a2).
	self assert: (p1 definesOrExtendsClass: a2).
	self assert: (p2 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-03-11T16:50:00+01:00'!
testMethodAddition
	"self debug: #testMethodAddition"

	| p1 a1 methodRef |
	p1 := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	a1 compileSilently: 'foo ^ 10'.
	p1 addMethod:  (a1>>#foo).
	self assert: (p1 includesSelector: #foo ofClass: a1).
	! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-04-25T17:33:00+01:00'!
testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt
	"self debug: #testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: a2 package = p2.
	p1 extensionMethods do: 
		[:each | self deny: each methodClass package = p1 ].
	"the package of a class which is extended inside a package p, is not p
	but the package where the class was defined"! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-03-11T16:46:00+01:00'!
testPackageOfClassForDefinedClasses
	"self debug: #testPackageOfClassForDefinedClasses"
	
	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPAckageP1 inPackage: p.
	b1 := self createNewClassNamed: #B1InPAckageP1 inPackage: p.

	self assert: a1 package = p.
	self assert: b1 package = p.
! !

!RPackageIncrementalTest methodsFor: 'test registration' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testPrivateClassRegisterUnregister
	"Verify that when we register a class, the package organizer register it."
	"self debug: #testPrivateClassRegisterUnregister"

	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPackageP1.
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independantly from addClassDefinition:"
		"No event should be raised."
	p registerClass: a1.
	self assert: (self packageClass organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClass: a1.
	self assert: (self packageClass organizer packageOf: a1) isDefault.
	
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independant from addClassDefinition:"
	p registerClassName: a1 name.
	self assert: (self packageClass organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClassName: a1 name.
	self assert: (self packageClass organizer packageOf: a1) isDefault
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testRemoveClassAfterMethods
	"self debug: #testRemoveClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	
	"now we add a new method to the class and the to the package: it is considered
	as defined"
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = 0.
	
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not defined anymore but an extension "
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testUniqueClassInDefinedClassesUsingAddClassDefinition
	"self debug: #testUniqueClassInDefinedClassesUsingAddClassDefinition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1 class.
	self assert: p definedClasses size = 1.

! !

RPackageIncrementalTest subclass: #RPackageObsoleteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 8/3/2012 14:21'!
testAnnouncementClassRemovedIsRaisedOnRemoveFromSystem
	"self debug: #testAnnouncementClassRemovedIsRaisedOnRemoveFromSystem"
	| notRun foo | 
	notRun := false.
	SystemAnnouncer uniqueInstance weak 
		on: ClassRemoved do: [:ann | notRun := true].
	foo := self createNewClassNamed: #FooForTest2.
	self deny: notRun.
	foo removeFromSystem.
	self assert: notRun. ! !

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 7/27/2012 19:40'!
testMethodPackageFromObsoleteClass
	"self debug: #testMethodPackageFromObsoleteClass"
	
	| pack method foo | 
	[
	pack := self createNewPackageNamed: 'P1'.
	foo := self createNewClassNamed: #FooForTest inPackage: pack.
	foo compile: 'bar ^42'.
	method := foo>>#bar.

	foo obsolete.
	self assert: (method packageFromOrganizer: pack organizer) equals: foo package.
	] ensure: [ 
		foo ifNotNil: [ 
			foo setName: foo originalName.
			foo removeFromSystem.
			].
		Smalltalk globals removeKey: #FooForTest  ifAbsent:  [].
	]! !

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/29/2012 13:25'!
testMethodPackageOfRemovedClass
	"self debug: #testMethodPackageOfRemovedClass"
	
	| pack method foo | 
	pack := self createNewPackageNamed: 'P1'.
	foo := self createNewClassNamed: #FooForTest2 inPackage: pack.
	foo compileSilently: 'bar ^42'.
	method := foo>>#bar.
	foo removeFromSystem.
	self deny: (pack includesClassNamed: #FooForTest2 )
	
	! !

RPackageIncrementalTest subclass: #RPackageReadOnlyCompleteSetupTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2 p4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageReadOnlyCompleteSetupTest commentStamp: 'StephaneDucasse 4/13/2011 17:10' prior: 0!
The tests takes as fixture the following situation and exercises the readonly queries.
We should be able to use a test resources to speed it up.

P1 
	A1DefinedInP1
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1
	
P2
	A2DefinedInP2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3 !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'expectedfailures' stamp: '2010-04-20T21:50:00+01:00'!
expectedFailures

	^ #(testClassNamesAndExtensionSelectorsDo testClassNamesAndExtensionSelectorsDo testClassesAndExtensionMethodsDo testClassesAndExtensionMethodsDo)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:43'!
setUp

	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:24'!
testAddTag
	"self debug: #testAddTag"
	
	self assert: p1 tags isEmpty.
	p1 addClassTag: #baz. 
	self assert: (p1 tags includes: #baz).
	self assert: (p1 tags size = 1).
	
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: (p1 tags includes: #foo).
	self assert: (p1 tags size = 2).
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	p1 addClassTag: #foo. 
	self assert: (p1 tags includes: #baz).
	self assert: (p1 tags includes: #foo).
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/25/2011 23:42'!
testAddTagsToAClass
	"self debug: #testAddTagsToAClass"
	
	self assert: p1 tags isEmpty.
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).

	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #zork.
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	self assert: ((p1 classesForClassTag: #zork) size = 1).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: 'StephaneDucasse 4/13/2011 17:09'!
testClassIsExtendedInPackage
	"self debug: #testClassIsExtendedInPackage"
	
	self deny: ((Smalltalk globals at: #A1DefinedInP1) isExtendedInPackage: p1).
	self assert: (p1 includesClass: (Smalltalk globals at: #A1DefinedInP1)).
	self deny: (p1 extendsClass: (Smalltalk globals at: #A1DefinedInP1)).
	self assert: ((Smalltalk globals at: #A2DefinedInP2) isExtendedInPackage: p1).
	self deny: (p1 includesClass: (Smalltalk globals at: #A2DefinedInP2)).
	self assert: (p1 extendsClass: (Smalltalk globals at: #A2DefinedInP2)).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:53:00+01:00'!
testClassNamesAndExtensionSelectorsDo2
	"self debug: #testClassNamesAndExtensionSelectorsDo2"
	

	self assert: (String streamContents: [:stream |
		{p1 . p2 .p3} do: [:p |
			p classNamesAndExtensionSelectorsDo: [:aClassName :selector |
				stream nextPutAll: aClassName  ; nextPutAll: ' ' ; nextPutAll:  selector asString; cr ]]])
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2_class classSideMethodDefinedInP3
'.
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:42:00+01:00'!
testClassesAndExtensionMethodsDo
	"self debug: #testClassesAndExtensionMethodsDo"
	
	| block |

	self assert: (String streamContents: [:stream |
		block := [ :aClass :selectors |
				stream nextPutAll: aClass name ; nextPutAll: ' '.
				selectors do: [ :selector | stream nextPutAll: selector asString].
				stream cr.].
		{p1 . p2 . p3} do: [ :p |
			p classExtensionSlicesDo: block.
			p metaclassExtensionSlicesDo: block.]]) 
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2 classSideMethodDefinedInP3
'! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-04-20T21:49:00+01:00'!
testCompiledMethodIsDefinedInPackage
	"self debug: #testCompiledMethodIsDefinedInPackage"
	
	self assert: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isDefinedInPackage: p1).
	self deny: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isDefinedInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-03-16T17:44:00+01:00'!
testCompiledMethodIsExtensionInPackage
	"self debug: #testCompiledMethodIsExtensionInPackage"
	
	self deny: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isExtensionInPackage: p1).
	self assert: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isExtensionInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testCompiledMethodPackageFromOrganizer
	"self debug: #testCompiledMethodPackageFromOrganizer"
	| method |
	method := (Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: self packageClass organizer) = p1.
	method := (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: self packageClass organizer) = p1! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testDefinedSelectorsForClass
	"self debug: #testDefinedSelectorsForClass"
	
	self assert: (p1 definedSelectorsForClass: a1) size = 2. 
	self assert: (p1 definedMethodsForClass: a1) size = 2. 
	self assert: ((p1 definedSelectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 definedSelectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: ((p1 definedMethodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: (p1 definedSelectorsForClass: Object) isEmpty. 
	self assert: (p1 definedSelectorsForClass: Object class) isEmpty. 
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/25/2011 22:30'!
testEmpty
	"self debug: #testEmpty"
	
	self assert: p1 tags isEmpty.
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:07:00+01:00'!
testExtendingPackagesOfClass
	"since a class can be extended by several packages, we want the list of packages that extend
	the class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	| packages |
	packages := a2 extendingPackages.
	"a2 is extended by p1 and p3"
	self assert: packages size = 2. 
	self assert: (packages includes: p1).
	self deny: (packages includes: p2).
	self assert: (packages includes: p3).
	
	packages := a1 extendingPackages.
	self assert: packages isEmpty. ! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-10-27T15:49:00+01:00'!
testExtensionMethods
	"a package can extend several classes, either the class or  the meta-class side. 'extensionMethods' should list all the methods involved in shuch extensions. P3 extend a2 and a2 class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	|package extensionMethods cpt |
	package := p3.
	self shouldnt: [extensionMethods := package extensionMethods] raise: Error.
	"self assert: (extensionMethods size = 2)."
	self assert: (extensionMethods includes: (a2>>#methodDefinedInP3)).
	self assert: (extensionMethods includes: (a2 class>>#classSideMethodDefinedInP3)).	

	cpt := 0.
	package metaclassExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #classSideMethodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.
	
	cpt := 0.
	package classExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #methodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-20T22:05:00+01:00'!
testExtensionSelectorsForClass
	"self debug: #testExtensionSelectorsForClass"
	
	self assert: (p1 extensionSelectorsForClass: a2) size = 1. 
	self assert: ((p1 extensionSelectorsForClass: a2) includes: #methodDefinedInP1).
	self assert: ((p1 extensionMethodsForClass: a2) includes: (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1).
	self assert: (p1 extensionSelectorsForClass: Object) isEmpty.
	self assert: (p1 extensionSelectorsForClass: Object class) isEmpty! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-03-13T13:48:00+01:00'!
testMetaclassHasExtensions
	"self debug: #testMetaclassHasExtensions"

	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2  name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofMetaclassName: a2 name).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofClass: a2 class)

	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:38:00+01:00'!
testMethods
	"self debug: #testMethods"
	
	| m1 m3 |
	m1 := p1 methods.
	self assert: m1 size = 3. 
	self assert: (m1 includes: a1>>#methodDefinedInP1).
	self assert: (m1 includes: a1>>#anotherMethodDefinedInP1). 
	self assert: (m1 includes: a2>>#methodDefinedInP1).
	m3 := p3 methods.
	self assert: m3 size = 2.
	self assert: (m3 includes: a2>>#methodDefinedInP3).
	self assert: (m3 includes: a2 class>>#classSideMethodDefinedInP3)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testMethodsForClass
	"self debug: #testMethodsForClass"
	
	self assert: (p1 methodsForClass: a1) size = 2. 
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#anotherMethodDefinedInP1)).
	self assert: (p1 methodsForClass: b1) isEmpty. 
	self assert: (p1 methodsForClass: Object) isEmpty. 
	self assert: (p1 methodsForClass: Object class) isEmpty. 

	self assert: (p3 methodsForClass: a2) size = 1.
	self assert: ((p3 methodsForClass: a2) includes: ((Smalltalk at: #A2DefinedInP2)>>#methodDefinedInP3)).
	self assert: (p3 methodsForClass: a2 class) size = 1.
	self assert:  ((p3 methodsForClass: a2 class) includes: ((Smalltalk at: #A2DefinedInP2) class>>#classSideMethodDefinedInP3))	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:08:00+01:00'!
testPackagesOfClass
	"since a class can be extended by several packages, we want the complete list of packages that define or extend
	the class"
	"self debug: #testPackagesOfClass"
		
	| packages extending |
	packages := a2 packages.
	"a2 is extended by p1 and p3"
	extending := a2 extendingPackages.
	self assert: extending size = 2. 
	self assert: (extending includes: p1).
	self assert: (extending includes: p3).
	
	self assert: packages size = 3. 
	self assert: (packages includes: p1).
	self assert: (packages includes: p2).
	self assert: (packages includes: p3).
	
	
	
	
	
	
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:12'!
testRemoveTag
	"self debug: #testRemoveTag"
	
	self assert: p1 tags isEmpty.
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	self shouldnt: [ (p1 removeClassTag: #bar)] raise: Error.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	p1 removeClassTag: #foo.
	self deny: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 0).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:19'!
testRemoveTaggedClasses
	"self debug: #testRemoveTaggedClasses"
	
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #zork.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	self deny: ((p1 classesForClassTag: #zork) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	
	"now when we remove a class"
	"from an existing tags list"
	p1 removeClassDefinitionName: #A1DefinedInP1 fromClassTag: #foo.
	self deny: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	
	"from a nonexisting tag list"
	self shouldnt: [p1 removeClassDefinitionName: #B1DefinedInP1 fromClassTag: #taz] raise: Error.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	
	"with a class not registered to a tag list"
	self shouldnt: [p1 removeClassDefinitionName: #Tagada fromClassTag: #foo] raise: Error.
	self deny: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:13:00+01:00'!
testSelectors
	"self debug: #testSelectors"
	
	self assert: (p1 selectors) size = 2. 
	self assert: ((p1 selectors) includes: #methodDefinedInP1).
	self assert: ((p1 selectors) includes: #anotherMethodDefinedInP1). 

	self assert: p3 selectors size = 2.
	self assert: (p3 selectors includes: #methodDefinedInP3).
	self assert:  (p3 selectors includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:58:00+01:00'!
testSelectorsForClass
	"self debug: #testSelectorsForClass"
	
	self assert: (p1 selectorsForClass: a1) size = 2. 
	self assert: ((p1 selectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 selectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: (p1 selectorsForClass: b1) isEmpty. 
	self assert: (p1 selectorsForClass: Object) isEmpty. 
	self assert: (p1 selectorsForClass: Object class) isEmpty. 

	self assert: (p3 selectorsForClass: a2) size = 1.
	self assert: ((p3 selectorsForClass: a2) includes: #methodDefinedInP3).
	self assert: (p3 selectorsForClass: a2 class) size = 1.
	self assert:  ((p3 selectorsForClass: a2 class) includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: 'StephaneDucasse 4/13/2011 20:52'!
testStartingSituation
	"self debug: #testStartingSituation"

.	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).
! !

RPackageIncrementalTest subclass: #RPackageTraitTest
	instanceVariableNames: 'p4 p5 a1 b1 a2 b2 a3 t1 t2 p6'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageTraitTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:42'!
p4Name

	^ 'RPackageTestP4'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:43'!
p5Name

	^ 'RPackageTestP5'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'cyrilledelaunay 5/10/2011 12:50'!
p6Name

	^ 'RPackageTestP6'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'cyrilledelaunay 5/13/2011 12:55'!
setUp

	super setUp.
	
	p4 := self createNewPackageNamed: self p4Name.  
	p5 := self createNewPackageNamed: self p5Name. 
	p6 := self createNewPackageNamed: self p6Name.  
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p4.
	
	"a1 defines two normal = local methods"
	a1 compileSilently: 'localMethodDefinedInP1 ^ #methodDefinedInP1'.
	p4 addMethod: (a1>>#localMethodDefinedInP1).
	a1 compileSilently: 'anotherLocalMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p4 addMethod: (a1>>#anotherLocalMethodDefinedInP1).
	
	t1 := self createNewTraitNamed: #TraitInPackageP4 inPackage: p4.
	t1 compileSilently: 'traitMethodDefinedInP4 ^ #traitMethodDefinedInP4'.
	p4 addMethod: (t1>>#traitMethodDefinedInP4).
	
	"P6 defines a new method extension on T1 (packaged in p4)"
	t1 compileSilently: 'traitMethodExtendedFromP6 ^ #traitMethodExtendedFromP6' classified: ('*',self p6Name). 
	p6 addMethod: (t1>>#traitMethodExtendedFromP6).
	
	t2 := self createNewTraitNamed: #TraitInPackageP5 inPackage: p5.
	t2 compileSilently: 'traitMethodDefinedInP5 ^ #traitMethodDefinedInP5'.
	
	p5 addMethod: (t2 >> #traitMethodDefinedInP5).  
	
	"Here P4 extends T2 from P5 with a new method"
	t2 compileSilently: 'traitMethodExtendedFromP4 ^ #traitMethodExtendedFromP4' classified: ('*',self p4Name). 
	p4 addMethod: (t2 >> #traitMethodExtendedFromP4).
	
	a1 setTraitComposition: (t1 + t2) asTraitComposition.
	
	"a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3)."
	! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testPackageOfClassMethodFromTraitExtensionIsExtendingPackage
	"The package of a method defined in atrait but package in another package than the extended trait is the 
	package containing the extension."
	
	"The package of a method in A1 (which is coming from the trait T1 used by A1) is the package of T1"
	self assert: ((a1>>#traitMethodExtendedFromP4) packageFromOrganizer: self packageClass organizer) = p4.
	"The package of a method in A1 (which is coming from the trait T1 used by A1 but extended in package T2) is the package of T2"
	self assert: ((a1>>#traitMethodExtendedFromP6) packageFromOrganizer: self packageClass organizer) = p6.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfClassMethodFromTraitIsTraitPackage

	"test that a class method coming from a trait is packaged in the trait package"
	self assert: ((a1>>#traitMethodDefinedInP4) packageFromOrganizer: self packageClass organizer) = p4.
	self assert: ((a1>>#traitMethodDefinedInP5) packageFromOrganizer: self packageOrganizerClass default) = p5.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfClassMethodIsClassPackage
	"The package of a local method (not defined in a trait) is the package of its class"
	
	self assert: ((a1>>#localMethodDefinedInP1) packageFromOrganizer: self packageClass organizer) = p4.
	self assert: ((a1>>#anotherLocalMethodDefinedInP1) packageFromOrganizer: self packageOrganizerClass default) = p4.
	self assert: ((a1>>#anotherLocalMethodDefinedInP1) packageFromOrganizer: self packageClass organizer) = p4.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfTraitMethodIsTraitPackage
	"The package of a trait method is the package of its trait."

	self assert: ((a1 >> #traitMethodDefinedInP5) packageFromOrganizer: self packageClass organizer) = p5.
	self assert: ((a1 >> #traitMethodDefinedInP5)packageFromOrganizer: self packageOrganizerClass default) = p5.
	self assert: ((a1>>#traitMethodDefinedInP4) packageFromOrganizer: self packageClass organizer) = p4.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/10/2011 10:24'!
testStartingSituation
	"self debug: #testStartingSituation"


.	self deny: (p5 includesClass: a1).
	self assert: (p4 includesClass: a1).
	self assert: (p4 includesClass: t1).
	self assert: (p4 definesOrExtendsClass: a1).
	self assert: (p5 includesClass: t2).! !

RPackageTestCase subclass: #RPackageOrganizerTest
	instanceVariableNames: 'createdClasses createdPackages organizer packageOrganizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageOrganizerTest commentStamp: 'StephaneDucasse 4/24/2011 17:10' prior: 0!
RPackageOrganizerTest tests the behavior of PackageOrganizer. 
Note that it does not rely on announcement to be emitted to maintain invariants.
Therefore the new created PackageOrganizer is not registered to listen to event.

!

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'RPackageTest'.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewPackageNamed: aName

	| pack |
	self removePackageIfExist: aName.
	pack := self packageClass named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p1Name
	^ 'RPackageTestP1'! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p2Name
	^ 'RPackageTestP2'! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p3Name
	^ 'RPackageTestP3'! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: 'StephaneDucasse 4/24/2011 17:13'!
packageOrganizer

	^ packageOrganizer ! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 6/3/2012 22:51'!
pointRectangleInGraphElement 
	| p |
	p := self packageClass named: #GraphElement.
	p addClassDefinition: Point.
	p addMethod: Point>>#x.
	p addMethod: Point>>#rotateBy:about:. 
	p addClassDefinition: Rectangle.
	p addMethod: Quadrangle>>#intersect:.
	^ p! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-07-29T21:54:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol

	Smalltalk globals at: aClassNameSymbol asSymbol ifPresent: [ :c | c removeFromSystem ]! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: 'cyrilledelaunay 5/30/2011 17:19'!
removePackageIfExist: aName

	self packageOrganizer basicUnregisterPackageNamed: aName asSymbol.
		
	! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setUp
	super setUp.
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.
	packageOrganizer := self packageOrganizerClass basicNew initialize.
	packageOrganizer debuggingName: 'For PackageOrganizerTest'.
	Author fullName ifNil: [Author fullName: 'RPackage'].! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 6/3/2012 22:51'!
stringCharacterInCollPackage
	| p |
	p := self packageClass named: #CollPackage.
	p addClassDefinition: String.
	p addClassDefinition: Character.
	p addMethod: String>>#indexOf:.
	p addMethod: String>>#isAllDigits.
	p addMethod: String class>>#cr.
	p addMethod: Character>>#asInteger.
	p addMethod: Text>>#allBold.
	^ p! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: 'StephaneDucasse 4/24/2011 17:12'!
tearDown 

	(createdClasses reject: [:c| c isObsolete])
		do: [:cls| 
				"(self packageClass organizer includesClass: cls)
					ifTrue: [self packageOrganizer unregisterClass: cls.]."
				cls removeFromSystem ].
	"createdPackages do:
		[:each | self packageOrganizer unregisterPackage: each]"! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:52'!
testAccessingPackage
	"self debug: #testAccessingPackage"

	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: (self packageOrganizer packageNamed: #P1) = p1.
	self should: [(self packageOrganizer packageNamed: #P22)] raise: Error! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:52'!
testDefinedClassesInstanceAndMetaSideAPI
	"self debug: #testDefinedClassesInstanceAndMetaSideAPI"
	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: self packageOrganizer packageNames size = 2.
	self assert: self packageOrganizer packages size = 2.
	self assert: (self packageOrganizer packageNamed: #P1) definedClasses size = 1! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:51'!
testEmpty
	"self debug: #testEmpty"
	self assert: self packageOrganizer packageNames size = 1.
	self assert: (self packageOrganizer packageNames includes: self packageClass defaultPackageName)
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:50'!
testFullRegistration
	"self debug: #testFullRegistration"

	| p1 p2 p3 a1 a2 b1 b2 a3 |
	"taken from setup of RPackageReadOnlyCompleteSetup"
	
p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:18'!
testFullUnregistration
	"self debug: #testFullRegistration"

	| p1 p2 p3 a1 a2 b1 b2 a3 |
	"taken from setup of RPackageReadOnlyCompleteSetup"
	
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	
	self packageOrganizer unregisterPackage: p1.
	self packageOrganizer unregisterPackage: p2.
	self packageOrganizer unregisterPackage: p3.
	

	self deny: (self packageOrganizer includesPackageBackPointerForClass: a1).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: a2).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: b1).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: b2).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: a3).
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:53'!
testRegisteredIsIncludedInPackageNames
	"self debug: #testRegisteredIsIncludedInPackageNames"
	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self assert: (self packageOrganizer includesPackage: p1). 
	self assert: (self packageOrganizer includesPackageNamed: p1 name). 
	{p1 . p2 . p3} do: [:each | self assert:  (self packageOrganizer packageNames includes: each name)]

! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:25'!
testRegisteredIsThere
	"self debug: #testRegisteredIsThere"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	
	{p1 . p2 . p3} do: [:each | 
		self assert:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:10'!
testRegisteredNumberOfPackageIsOk
	"self debug: #testRegisteredNumberOfPackageIsOk"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self packageOrganizer basicUnregisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 3.! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 4/24/2011 17:18'!
testRegistrationExtendingPackages
	"self debug: #testRegistrationExtendingPackages"

	| p |
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	p := self pointRectangleInGraphElement.
	(self packageOrganizer
					registerExtendingPackage:  p
					forClass: Quadrangle).
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:19'!
testUnregisterBasedOnNames
	"self debug: #testUnregisterBasedOnNames"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.

	{p1 . p2 . p3} do: [:each | 
		(self packageOrganizer basicUnregisterPackageNamed: each name).
		self deny:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: '2011-01-31T11:52:00+01:00'!
testUnregistrationExtendingPackages
	"self debug: #testUnregistrationExtendingPackages"

	| p |
	p := self pointRectangleInGraphElement.
	self packageOrganizer
		registerExtendingPackage: p
		forClass: Quadrangle.
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	self packageOrganizer
					unregisterExtendingPackage:  p
					forClass: Quadrangle.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	! !

!RPackageTestCase methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 19:43'!
allManagers

	^ MCWorkingCopy allManagers! !

!RPackageTestCase methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 8/3/2012 14:24'!
initializeAnnouncers
	oldSystemAnnouncer := SystemAnnouncer uniqueInstance.

	SystemAnnouncer announcer: (announcerForTest := SystemAnnouncer new).! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:44'!
organizer
	"This method will access the organizer that will temporarily swapped using the withOrganizer:do: method"
	^ self packageClass organizer! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:44'!
packageClass 
	"returns the system class that represents Packages"
	^ RPackage ! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 23:25'!
packageOrganizerClass 
	"returns the package organizer class"
	^ RPackageOrganizer! !

!RPackageTestCase methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 8/3/2012 14:23'!
restoreAnnouncers
	SystemAnnouncer announcer: oldSystemAnnouncer.
! !

!RPackageTestCase methodsFor: 'running' stamp: 'GuillermoPolito 7/23/2012 13:45'!
runCase
	[
	self initializeAnnouncers.
	
	^ self packageClass 
		withOrganizer: self setupOrganizer
		do: [ 
			self resources do: [:each | each availableFor: self].
			self setUp.
			self performTest
			]
	] ensure: [ 
		self tearDown.
		self restoreAnnouncers.
		self cleanUpInstanceVariables
	]! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setupOrganizer
	^ self packageOrganizerClass basicNew initialize; debuggingName: 'Organizer for RPackageTest'; yourself! !

TestCase subclass: #RPackageWithDoTest
	instanceVariableNames: 'x'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageWithDoTest methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/3/2012 14:24'!
announcer
	^ SystemAnnouncer uniqueInstance private! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:17'!
do: aBlock 

	x := 5.
	[aBlock value] ensure: [x :=3.]! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 12:26'!
doC: aBlock 
	
	x := 5.
	[aBlock value] ifCurtailed: [x :=3]! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:24'!
doOnDo: aBlock 
	
	x := 5.
	[aBlock value.
	self ensure] on: Error do:  [:ex | self ensure].! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:24'!
ensure

	x := 3! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'IgorStasenko 8/12/2011 16:37'!
info
	
	
	self announcer hasSubscriber: RPackageOrganizer default.
	Smalltalk garbageCollect.
	RPackageOrganizer allInstances collect: [:each | self announcer hasSubscriber: each ] ! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:49'!
packageClass
	^ RPackage! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
packageOrganizerClass
	^ RPackageOrganizer! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:19'!
testDo
	"self run: #testDo"
	
	[self do: [ Error signal]] on:Error do: [:ex|].
	"necessary else SUnit believe that the error is not handle"
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:14'!
testDo2
	"self run: #testDo2"
	
	[self do: [ self error]
		] on: Error do: [:ex | ].
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:20'!
testDoC
	"self run: #testDoC"
	
	[self doC: [ self error]] on: Error do: [:e|].
	"necessary for SUnit"
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
testInvariant
	"The default invariant"
	"self run: #testInvariant"
	
	self assert: (self packageOrganizerClass default packageNames size > 50).
	"to be sure that this is real default one"
	self assert: (self announcer hasSubscriber: self packageOrganizerClass default).
	"note that this test is not precise enough because I could get the wrong one."
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	self assert: (self packageOrganizerClass allInstances size = 1).
	
	self packageOrganizerClass allInstances collect: [:each | self announcer hasSubscriber: each ] 
	"To debug..."! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:20'!
testOnDo
	"self run: #testOnDo"
	
	self doOnDo: [ self error].
	self assert: x = 3.
	x := 77.
	self doOnDo: [x = 21].
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'EstebanLorenzano 8/3/2012 15:05'!
testWithDoIsCorrectlyReinstallingDefault
	"self debug: #testWithDoIsCorrectlyReinstallingDefault"
	
	| current empty |

	current := self packageOrganizerClass default.  
	empty := self packageOrganizerClass basicNew initialize.
	empty debuggingName: 'empty from PackageWithDoTest'.
	self packageClass 
		withOrganizer: empty
		do: [ 
			self assert: (self announcer hasSubscriber: empty).
			self deny: (self announcer hasSubscriber: current)].
	self assert: (self announcer hasSubscriber: current).
	self deny: (self announcer hasSubscriber: empty)! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'EstebanLorenzano 8/3/2012 14:51'!
testWithDoIsCorrectlyReinstallingDefaultEvenIfHalt
	"self debug: #testWithDoIsCorrectlyReinstallingDefaultEvenIfHalt"
	
	| current empty |
	current := self packageOrganizerClass default.  
	empty := self packageOrganizerClass basicNew initialize.
	[ self packageClass 
		withOrganizer: empty
		do: [ 		
			self assert: (self announcer hasSubscriber: empty).
			self deny: (self announcer hasSubscriber: current).
			self error ] ]
		on: Error do: [:ex|].
	
	self assert: (self announcer hasSubscriber: current).
	self deny: (self announcer hasSubscriber: empty)
		
		


! !
MCMockRPackage initialize!
